/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.object;

import net.buildism.BuildismException;
import net.buildism.Main;


public class AssetService extends GameObject{
    public AssetService() throws BuildismException
    {
        super("AssetService");
        explorable = false;
        //x_;
    }
    @Override
    public void addToWorld() throws BuildismException
    {
        if(world == Main.getGame().getMainWorld())
        {
            addSound("Click");
            addSound("Click2");
            addSound("Explode");
            addSound("Tick");
            addSound("Rocket");
            addSound("BigExplode");
        }
    }
    private void addSound(String name) throws BuildismException
    {
        Sound s = (Sound) world.createObject("Sound");
        s.setProp("Name", name, true);
        s.setProp("Sound", "resource://sounds/"+name+".wav", true);
        s.setParent(this);
    }
    public void playSound(String name) throws BuildismException
    {
        if(hasChild(name))
            ((Sound)getChild(name)).play();
    }
}
