/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.object;

import java.awt.Color;
import net.buildism.BuildismException;
import net.buildism.PropChangeHandler;
import net.buildism.ui.edge.EFrame;


public class UIFrame extends UIComponent{
    public UIFrame() throws BuildismException
    {
        super("UIFrame");
        component = new EFrame(null, 0, 0, 0, 0);
        addPropChangeHandler("BackgroundColor", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                ((EFrame)component).setBackgroundColor(((Color)value));
            }
        });
        addPropChangeHandler("BorderColor", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                ((EFrame)component).setBorderColor(((Color)value));
            }
        });
        addPropChangeHandler("Undecorated", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                ((EFrame)component).setUndecorated((Boolean)value);
            }
        });
    }
}
