/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.object;

import java.awt.Color;
import net.buildism.BuildismException;
import net.buildism.PropChangeHandler;
import net.buildism.ui.edge.ELabel;


public class UILabel extends UIComponent{
    public UILabel() throws BuildismException
    {
        super("UILabel");
        component = new ELabel("Text");
        addPropChangeHandler("Text", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                ((ELabel)component).setText(value.toString());
            }
        });
        addPropChangeHandler("TextColor", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                ((ELabel)component).setColor(((Color)value));
            }
        });
    }
}
