/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.object;

import java.awt.Color;
import net.buildism.BuildismException;
import net.buildism.PropChangeHandler;
import net.buildism.ui.edge.EFrame;
import net.buildism.ui.edge.EStickyFrame;


public class UIStickyFrame extends UIComponent{
    public UIStickyFrame() throws BuildismException
    {
        super("UIStickyFrame");
        component = new EStickyFrame(null, 0, 0, 0, 0, 0, 0);
        addPropChangeHandler("MarginLeft", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                ((EStickyFrame)component).leftMargin = (Integer) value;
            }
        });
        addPropChangeHandler("MarginRight", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                ((EStickyFrame)component).rightMargin = (Integer) value;
            }
        });
        addPropChangeHandler("MarginTop", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                ((EStickyFrame)component).topMargin = (Integer) value;
            }
        });
        addPropChangeHandler("MarginBottom", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                ((EStickyFrame)component).bottomMargin = (Integer) value;
            }
        });
        addPropChangeHandler("BackgroundColor", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                ((EFrame)component).setBackgroundColor(((Color)value));
            }
        });
        addPropChangeHandler("BorderColor", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                ((EFrame)component).setBorderColor(((Color)value));
            }
        });
        addPropChangeHandler("Undecorated", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                ((EFrame)component).setUndecorated((Boolean)value);
            }
        });
    }
}
