/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.ui;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.MutableTreeNode;
import net.buildism.BuildismException;
import net.buildism.Main;
import net.buildism.object.GameObject;
import net.buildism.object.World;


public class PartTreeNode extends DefaultMutableTreeNode {
    private GameObject obj;
    public PartTreeNode(GameObject obj)
    {
        setUserObject(this);
        this.obj = obj;
    }
    public GameObject getObject()
    {
        return obj;
    }
    @Override
    public void add(MutableTreeNode c)
    {
        super.add(c);
        if(!Main.noView)
            Main.getApplet().getPartsTree().getModel().nodesWereInserted(this, new int[]{getIndex(c)});
    }
    public void remove()
    {

    }
    @Override
    public String toString()
    {
        try {
            return obj.getStringProp("Name");
        } catch (BuildismException ex) {
            return "";
        }
    }
}
