/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.ui;

import net.buildism.ui.UI;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.TreePath;
import net.buildism.BuildismException;
import net.buildism.object.GameObject;


public class PartsTreeSelectionListener implements TreeSelectionListener{

    public void valueChanged(TreeSelectionEvent e) {
        for(TreePath p : e.getPaths())
        {
            if(!(p.getLastPathComponent() instanceof PartTreeNode))
                throw new RuntimeException("illegal tree node type");
            else if(e.isAddedPath(p))
            {
                PartTreeNode n = (PartTreeNode) p.getLastPathComponent();
                GameObject part = n.getObject();
                UI.select(part);
            }
            else if(!e.isAddedPath(p))
            {
                PartTreeNode n = (PartTreeNode) p.getLastPathComponent();
                GameObject part = n.getObject();
                UI.deselect(part);
            }
        }
        try {
            UI.updateSelection();
        } catch (BuildismException ex) {
            throw new RuntimeException(ex);
        }
    }

}
