/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.object;

import net.buildism.BuildismException;
import net.buildism.Main;
import net.buildism.PropChangeHandler;


public class Team extends GameObject{
    public Team() throws BuildismException
    {
        super("Team");
        addPropChangeHandler("Name", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                if(oldValue != null && world == world.game.getMainWorld() && getParent() instanceof Teams)
                {
                    world.game.removeTeam(oldValue.toString());
                    world.game.addTeam(Team.this);
                }
            }
        });
    }
}
