/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.ui;

import java.awt.Component;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.EventObject;
import javax.swing.AbstractCellEditor;
import javax.swing.JCheckBox;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.CellEditorListener;
import javax.swing.table.TableCellEditor;
import net.buildism.component.JColorPicker;


public class SettingsTableCellEditor extends AbstractCellEditor implements TableCellEditor{
    private int row;
    private int column;
    private Component component;
    private String key;
    public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
        key = (String) table.getModel().getValueAt(row, 0);
        this.row = row;
        this.column = column;
        component = SettingsTableCellComponent.getComponentFor(this, column, key, value);
        if(component instanceof JCheckBox)
        {
            ((JCheckBox)component).addItemListener(new ItemListener()
            {

                public void itemStateChanged(ItemEvent e) {
                    stopCellEditing();
                }

            });
        }
        return component;
    }

    public Object getCellEditorValue() {
        if(component instanceof JCheckBox)
        {
            return ((JCheckBox)component).getSelectedObjects() != null;
        }
        else if(component instanceof JTextField)
        {
            return ((JTextField)component).getText();
        }
        else if(component instanceof JColorPicker)
        {
            return ((JColorPicker)component).getValue();
        }
        else
        {
            throw new RuntimeException("Invaid component type for property editor");
        }
    }
}
